﻿没有金刚钻，不揽瓷器活。
为了能够掌握并运用PID，我们非常有必要学习下基本概念来武装自己，部分概念后面我会配上实际工程中常用的表示方法，以“实：”开头。

1. 被调量:反映被调对象的实际波动的量值。被调量是经常变化的。  
   实：常用检测到的反馈值表示，如yout(t)。

2. 设定值:PID调节器设定值就是人们期待被调量需要达到的值。设定值可以是固定的，也可以是变化的。  
   实：人为设定，多用rin(t)表示。

3. 控制输出：PID调节器根据被调量的变化情况运算之后发出的让外部执行结构按照它的要求动作的指令，即整个调节器的输出。请注意与被调量yout(t)的区别，这两个是完全不同的概念，经常有人在混淆这两个概念。  
   实：你经常看到的公式“u(t)=kp[e(t)+1/TI∫e(t)dt+TD*de(t)/dt]”中的u(t)。

4. 输入偏差：输入偏差时被调量和设定值之间的差值。  
   实：error(t)=rin(t)-yout(t)。

5. P（比例）：P就是比例作用，简单说就是输入偏差乘以一个系数。  
   实：如kp，KP都是一样的。

6. I（积分）：I就是积分，简单说就是将输入偏差进行积分运算。  
   实：如ki。

7. D（积分）：D就是微分，简单说就是将输入偏差进行微分运算。  
   实：如kd。

8. PID基本公式PID调节器参数整定过程通俗讲就是先把系统调为纯比例作用，逐步增强比例作用让系统产生等幅振荡，记录下比例作用和振荡周期，然后这个比例作用乘以0.6，积分作用适当延长  
	```c
		KP= 0.6*Km
		KD= KP*π/4ω 或 KD= KP*tu/8
		KI= KP*ω/π  或 KI= 2KP/tu
	```
	KP：比例控制参数；  
	KD：积分控制参数；  
	KI：微分控制参数；  
	Km：系统开始振荡时的比例值，通常称为临界比例值；  
	ω：等幅振荡时的频率，tu为振荡周期。这里 tu*ω =2π，而不是tu*ω=1，学过傅里叶和拉氏变换的同学应该明白这是为什么，这里不做深入探讨。  

9. 单回路：单回路就是只有一个PID的调节系统。  

10. 串级：一个PID不够用，串级就是把两个PID串接起来形成一个串级调节系统，也被成为双回路调节系统。串级调节系统里PID调节器有主调和副调之分。    
在串级调节系统中要调节被调量的PID叫做主调，输出直接去指挥执行器动作的PID叫做副调，主调的控制输出进入副调作为副调的设定值。主调选用单回路PID调节器，副调选用外给定调节器。

11. 正作用  
对于PID调节器而言，控制输出随被调量增高而增高，随被调量减少而减少的作用，叫做PID正作用。

12. 负作用  
对于PID调节器而言，控制输出随被调量增高而降低，随被调量减少而增高的作用，叫做PID负作用。

13. 动态偏差  
在调节过程中，被调量和设定值之间的偏差随时改变，任意时刻两者之间的偏差叫做动态偏差。

14. 静态偏差  
    调节趋于稳定之后，被调量和设定值之间还存在的偏差交静态偏差。消除静态偏差是通过PID调节器积分作用来实现的。

15. 回调  
调节器调节作用显示，使被调量开始由上升变为下降，或者由下降变为上升趋势成为回调。